#include "FGToken.h"

#include "CharUtils.h"

using namespace std;

namespace egstra {
  void fg_token::phi(const sentence* const x, list<string> F[],
		     const int word_limit,
		     const bool use_pos) {
    const int N = x->size();
    for(int i = 0; i < N; ++i) {
      list<string>& f_i = F[i];

      /* the token to be inspected */
      const token& tok = x->get_token(i);

      string wstr;
      string lstr;
      string cstr;
      string fstr;
      if(tok.word() < word_limit) {
	toString(tok.word(), wstr);
      } else {
	wstr = "-2";
      }
      toString(tok.lemma(), lstr);

      /* the word */
      f_i.push_back("word:" + wstr);

      /* the lemma, if available */
      if(tok.lemma() >= 0){
	f_i.push_back("lemma:" + lstr);
      }

      if(use_pos) {
	toString(tok.coarse_tag(), cstr);
	toString(tok.fine_tag(), fstr);

	/* the coarse POS */
	f_i.push_back("ctag:" + cstr);

	/* the fine-grained POS, if available */
	if(tok.fine_tag() >= 0){
	  f_i.push_back("ftag:" + fstr);
	}

	/* word + coarse POS */
	f_i.push_back("word+ctag:" + wstr + "+" + cstr);
      }

      /* the morpho-syntactic features, if available */
      for(list<int>::const_iterator it = tok.morphos().begin();
	  it != tok.morphos().end(); it ++){
	string mstr;
	toString(*it, mstr);
	f_i.push_back("morpho:" + mstr);
	f_i.push_back("word+morpho:" + wstr + "+" + mstr);
      }
    }
  }
}
