/**
 * Implements the sentence class
 * @file sentence.h
 * @author Mihai Surdeanu
 */

#ifndef EGSTRA_SENTENCE_H
#define EGSTRA_SENTENCE_H

#include <vector>

#include "Pattern.h"
#include "Token.h"

namespace egstra {

  class sentence : public pattern {
  private:
    std::vector<token> mTokens;

  public:
    sentence() {}

    /** Adds a token to the end of the sentence */
    void add_token(const token & t) { mTokens.push_back(t); }

    /** Fetches the token at the given position */
    const token & get_token(int position) const { return mTokens[position]; }

    bool empty() const { return mTokens.empty(); }
  };

}

#endif /* EGSTRA_SENTENCE_H */
