/* Example : abstract class representing an (x_i,y_i) pair

   Make a subclass of this class and provide a definition for read()
   that sets x and y to the proper values.

   Author : Terry Koo
            maestro@csail.mit.edu */

#ifndef EGSTRA_EXAMPLE_H
#define EGSTRA_EXAMPLE_H

#include "Pattern.h"
#include "Label.h"

namespace egstra {
  class example {
  protected:
    pattern* _x;
    label* _y;

  public:
    example(pattern* x, label* y)
      : _x(x), _y(y) {}
    ~example() {
      delete _x;
      delete _y;
    }

    /* accessors */
    const pattern* x() const { return _x; }
    const label& y() const   { return *_y; }
  };
}

#endif /* EGSTRA_EXAMPLE_H */
