/**
 * Contains some string manipulation functions
 * @file CharUtils.h
 * @author Mihai Surdeanu
 */

#include <string>
#include <vector>
#include <sstream>

#ifndef EGSTRA_CHAR_UTILS_H
#define EGSTRA_CHAR_UTILS_H

namespace egstra {

  void simpleTokenize(const std::string & input,
		      std::vector<std::string> & output,
		      const std::string & separators);

  bool emptyLine(const std::string & input);

  int toInteger(const std::string & s);

  void toString(const int i, std::string& s);

  std::string toUpper(const std::string & s);

  std::string toLower(const std::string & s);

  bool startsWith(const std::string & big,
		  const std::string & small);

  bool endsWith(const std::string & big,
		const std::string & small);

  std::string stripString(const std::string & s,
			  int left,
			  int right);
}

#endif /* EGSTRA_CHAR_UTILS_H */
