#include "LLDEGTrainer.h"

#include "DEGTrainer.h"
#include "ObjectiveFunction.h"

using namespace std;

namespace egstra {
  lldeg_trainer::lldeg_trainer()
    : trainer(), _impl(new deg_trainer<obj_loglinear>())
  {}

  lldeg_trainer::~lldeg_trainer() {
    delete _impl;
  }

  void lldeg_trainer::usage(const char* const mesg) {
    assert(_impl != NULL);
    _impl->usage(mesg);
  }

  void lldeg_trainer::process_options() {
    assert(_impl != NULL);
    _impl->process_options();
  }

  void lldeg_trainer::train(dataset& trdata, dataset& valdata,
			    const int T) {
    assert(_impl != NULL);
    _impl->set_model(_M);
    _impl->set_fgen(_fg);
    _impl->set_dir(_dir);
    _impl->train(trdata, valdata, T);
  }
}
