/************************************************************
 *
 *   Author : Terry Koo
 *            maestro@csail.mit.edu
 *
 *   LLDEGTrainer : trains a log-linear model by minimizing the
 *                  regularized condiitonal log-likelihood
 *
 ************************************************************/
#ifndef EGSTRA_LLDEGTRAINER_H
#define EGSTRA_LLDEGTRAINER_H

#include "Trainer.h"
#include "Register.h"

/* this class is just a wrapper that instantiates a template */

namespace egstra {
  class lldeg_trainer : public trainer {
  private:
    trainer* _impl; /* the actual implementation */

  public:
    lldeg_trainer();
    ~lldeg_trainer();

    void usage(const char* const mesg = "");
    void process_options();

    void train(dataset& trdata, dataset& valdata, const int T);

  };

  REGISTER_TRAINER(lldeg, lldeg_trainer);
}

#endif /* EGSTRA_LLDEGTRAINER_H */
