/************************************************************
 *
 *   Author : Terry Koo
 *            maestro@csail.mit.edu
 *
 *   LLSGDTrainer : trains a log-linear model by minimizing the
 *                  regularized condiitonal log-likelihood
 *
 ************************************************************/
#ifndef EGSTRA_LLSGDTRAINER_H
#define EGSTRA_LLSGDTRAINER_H

#include "Trainer.h"
#include "Register.h"

/* this class is just a wrapper that instantiates a template */

namespace egstra {
  class llsgd_trainer : public trainer {
  private:
    trainer* _impl; /* the actual implementation */

  public:
    llsgd_trainer();
    ~llsgd_trainer();

    void usage(const char* const mesg = "");
    void process_options();

    void train(dataset& trdata, dataset& valdata, const int T);

  };

  REGISTER_TRAINER(llsgd, llsgd_trainer);
}

#endif /* EGSTRA_LLSGDTRAINER_H */
