/************************************************************
 *
 *   Author : Terry Koo
 *            maestro@csail.mit.edu
 *
 *   MMDEGTrainer : trains a max-margin model by minimizing the
 *                  regularized (Taskar-style) hinge loss
 *
 ************************************************************/
#ifndef EGSTRA_MMDEGTRAINER_H
#define EGSTRA_MMDEGTRAINER_H

#include "Trainer.h"
#include "Register.h"

/* this class is just a wrapper that instantiates a template */

namespace egstra {
  class mmdeg_trainer : public trainer {
  private:
    trainer* _impl; /* the actual implementation */

  public:
    mmdeg_trainer();
    ~mmdeg_trainer();

    void usage(const char* const mesg = "");
    void process_options();

    void train(dataset& trdata, dataset& valdata, const int T);

  };

  REGISTER_TRAINER(mmdeg, mmdeg_trainer);
}

#endif /* EGSTRA_MMDEGTRAINER_H */
