/************************************************************
 *
 *   Author : Terry Koo
 *            maestro@csail.mit.edu
 *
 *   MMSGDTrainer : trains a max-margin model by minimizing the
 *                  regularized (Taskar-style) hinge loss
 *
 ************************************************************/
#ifndef EGSTRA_MMSGDTRAINER_H
#define EGSTRA_MMSGDTRAINER_H

#include "Trainer.h"
#include "Register.h"

/* this class is just a wrapper that instantiates a template */

namespace egstra {
  class mmsgd_trainer : public trainer {
  private:
    trainer* _impl; /* the actual implementation */

  public:
    mmsgd_trainer();
    ~mmsgd_trainer();

    void usage(const char* const mesg = "");
    void process_options();

    void train(dataset& trdata, dataset& valdata, const int T);

  };

  REGISTER_TRAINER(mmsgd, mmsgd_trainer);
}

#endif /* EGSTRA_MMSGDTRAINER_H */
