/************************************************************
 *
 *   Author : Xavier Carreras
 *            carreras@csail.mit.edu
 *
 *   Decoder : A trainer that just goes through a set of test data and
 *             assigns argmax labels according to oracle scores.
 *
 ************************************************************/
#ifndef EGSTRA_ORACLE_H
#define EGSTRA_ORACLE_H

#include "Trainer.h"
#include "Register.h"

#include <string>

namespace egstra {
  class oracle_decoder : public trainer {
  private:
    /* active if scores are randome generated */
    bool _random;
    /* name for the ouput file */
    std::string _output;
    

  public:
    oracle_decoder() : trainer(), _random(false) {}
    ~oracle_decoder() {}

    void usage(const char* const mesg = "");
    void process_options();

    void train(dataset& trdata, dataset& valdata, const int T);

  };

  REGISTER_TRAINER(oracle, oracle_decoder);
}


#endif /* EGSTRA_ORACLE_H */
